import pickle

if __name__ == "__main__":
    selected = ['', '', 0, 0, 0]  # 비교하기 위해 임시로 저장할 곳
    preProcessedData = []  # 모두 비교후, 선택된 애들이 저장될 곳

    # read routing table
    f = open('oix-full-snapshot-2019-11-28-0600', 'r')

    # delete top 5 line
    for i in range(0, 5):
        f.readline()

    # first line for compare
    line = f.readline()

    while line:
        # 얘들은 새로 읽은 애들의 데이터
        splitedLine = line.split()
        netIP = splitedLine[1]
        hop = splitedLine[2]
        weight = int(splitedLine[5])
        preference = int(splitedLine[4])
        path = len(splitedLine) - 7

        # if not same IP
        if selected[0] != netIP:
            selected = [netIP, hop, weight, preference, path]

        # same IP
        else:
            # first, compare with weight
            if weight > selected[2]:
                selected = [netIP, hop, weight, preference, path]

            # second, compare with preference
            elif weight == selected[2] and preference > selected[3]:
                selected = [netIP, hop, weight, preference, path]

            # third, compare with length of path
            elif weight == selected[2] and preference == selected[3] and path < selected[4]:
                selected = [netIP, hop, weight, preference, path]

        nextLine = f.readline()

        # if last line
        if nextLine == '':
            preProcessedData.append([netIP, selected[1]])
            print('lastLine')
            break

        # if not same between next IP and selected IP, save selected IP cus selected IP is all compared
        splitedNextLine = nextLine.split()
        if splitedNextLine[1] != netIP:
            preProcessedData.append([netIP, selected[1]])

        # cus while line
        line = nextLine

    with open('realResult.txt', 'w') as f:
        for i in preProcessedData:
            tmp = i[0] + ' ' + i[1] + '\n'
            f.write(tmp)


